diff -bruN freeswan-1.9.orig/klips/net/ipsec/ipsec_tunnel.c freeswan-1.9/klips/net/ipsec/ipsec_tunnel.c
--- freeswan-1.9.orig/klips/net/ipsec/ipsec_tunnel.c	Mon Feb 26 19:51:00 2001
+++ freeswan-1.9/klips/net/ipsec/ipsec_tunnel.c	Tue Jun 12 16:35:03 2001
@@ -1369,11 +1528,7 @@
 					((__u32*)(tdbp->tdb_iv))[1] =
 						((__u32 *)(idat))[(ilen >> 2) - 1];
 					break;
-#endif /* defined(CONFIG_IPSEC_ENC_3DES) */
-#ifdef CONFIG_IPSEC_ENC_NULL
-				case ESP_NULL:
-					break;
-#endif /* CONFIG_IPSEC_ENC_NULL */
+#endif /* defined(CONFIG_IPSEC_ENC_DES) || defined(CONFIG_IPSEC_ENC_3DES) */
 				default:
 					spin_unlock(&tdb_lock);
 					stats->tx_errors++;
@@ -1540,10 +1695,14 @@
 				/* XXX use of skb->dst below is a questionable
 				   substitute for &rt->u.dst which is only
 				   available later-on */
+#ifdef IP_SELECT_IDENT_NEW
+				ip_select_ident(iph, skb->dst, NULL);
+#else /* IP_SELECT_IDENT_NEW */
 				ip_select_ident(iph, skb->dst);
-#else
+#endif /* IP_SELECT_IDENT_NEW */
+#else /* IP_SELECT_IDENT */
 				iph->id       = htons(ip_id_count++);   /* Race condition here? */
-#endif
+#endif /* IP_SELECT_IDENT */
 
 				newdst = (__u32)iph->daddr;
 				newsrc = (__u32)iph->saddr;
@@ -1559,7 +1718,7 @@
 					unsigned int flags = 0;
 #ifdef CONFIG_IPSEC_DEBUG
 					unsigned int old_tot_len = ntohs(iph->tot_len);
-#endif
+#endif /* CONFIG_IPSEC_DEBUG */
 					tdbp->tdb_comp_ratio_dbytes += ntohs(iph->tot_len);
 
 					skb = skb_compress(skb, tdbp, &flags);
@@ -1610,7 +1769,8 @@
 			KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 				    "klips_debug:ipsec_tunnel_start_xmit: "
 				    "after <%s%s%s>, SA:%s:\n",
-				    TDB_XFORM_NAME(tdbp), sa);
+				    TDB_XFORM_NAME(tdbp),
+				    sa_len ? sa : " (error)");
 			KLIPS_IP_PRINT(debug_tunnel & DB_TN_XMIT, iph);
  			
 			tdbp->tdb_lifetime_bytes_c += len;
@@ -1620,6 +1780,7 @@
 			tdbp->tdb_lifetime_usetime_l = jiffies / HZ;
 			tdbp->tdb_lifetime_packets_c += 1;
 
+			tdbprev = tdbp;
 			tdbp = tdbp->tdb_onext;
 			
 		}
@@ -1633,14 +1794,18 @@
 		er = ipsec_findroute(&matcher);
 		if(er) {
 			outgoing_said = er->er_said;
+			eroute_pid = er->er_pid;
+			er->er_count++;
+			er->er_lasttime = jiffies/HZ;
 		}
 		spin_unlock(&eroute_lock);
-		KLIPS_PRINT(/* ((orgdst != newdst) || (orgsrc != newsrc)) */
+		KLIPS_PRINT((debug_tunnel & DB_TN_XMIT) &&
+			    /* ((orgdst != newdst) || (orgsrc != newsrc)) */
 			(orgedst != outgoing_said.dst.s_addr) &&
 			outgoing_said.dst.s_addr &&
-			er &&
-			(debug_tunnel & DB_TN_XMIT),
-			"klips_debug:ipsec_tunnel_start_xmit: We are recursing here.\n");
+			    er,
+			    "klips_debug:ipsec_tunnel_start_xmit: "
+			    "We are recursing here.\n");
 	} while(/*((orgdst != newdst) || (orgsrc != newsrc))*/
 		(orgedst != outgoing_said.dst.s_addr) &&
 		outgoing_said.dst.s_addr &&
@@ -1664,9 +1829,9 @@
 
 	if(saved_header) {
 		if(skb_headroom(skb) < hard_header_len) {
-			printk(KERN_WARNING "klips_error:ipsec_tunnel_start_xmit: "
-			       "tried to skb_push hhlen=%d, %d available.  "
-			       "This should never happen, please report.\n",
+			printk(KERN_WARNING
+			       "klips_error:ipsec_tunnel_start_xmit: "
+			       "tried to skb_push hhlen=%d, %d available.  This should never happen, please report.\n",
 			       hard_header_len, skb_headroom(skb));
 			stats->tx_errors++;
 			goto cleanup;
@@ -1682,28 +1847,21 @@
 		    "With hard_header, final head,tailroom: %d,%d\n",
 		    skb_headroom(skb), skb_tailroom(skb));
 
-#ifdef NET_21
+#ifdef NET_21	/* 2.2 and 2.4 kernels */
 	/* new route/dst cache code from James Morris */
 	skb->dev = physdev;
 	/*skb_orphan(skb);*/
-#ifdef NETDEV_23
-	if(sysctl_ipsec_no_eroute_pass) {
-		/* zero the saddr used in ip_route_output */
-		route_saddr=0;
-	}else{
-		route_saddr=skb->nh.iph->saddr;
-	}
-#endif /* NETDEV_23 */
-	if(ip_route_output(&rt,
+	if((error = ip_route_output(&rt,
 			   skb->nh.iph->daddr,
-#ifdef NETDEV_23
-			   route_saddr,
-#else /* NETDEV_23 */
-			   skb->nh.iph->saddr,
-#endif /* NETDEV_23 */
+				   pass ? 0 : skb->nh.iph->saddr,
 			   RT_TOS(skb->nh.iph->tos),
-			   physdev->iflink)) {
+				   physdev->iflink))) {
 		stats->tx_errors++;
+		KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
+			    "klips_debug:ipsec_tunnel_start_xmit: "
+			    "ip_route_output failed with error code %d, rt->u.dst.dev=%s, dropped\n",
+			    error,
+			    rt->u.dst.dev->name);
 		goto cleanup;
 	}
 	if(dev == rt->u.dst.dev) {
@@ -1719,11 +1877,11 @@
 	skb->dst = &rt->u.dst;
 	stats->tx_bytes += skb->len;
 	if(skb->len < skb->nh.raw - skb->data) {
-		printk(KERN_WARNING "klips_error:ipsec_tunnel_start_xmit: "
-		       "tried to __skb_pull nh-data=%d, %d available.  "
-		       "This should never happen, please report.\n",
-		       skb->nh.raw - skb->data, skb->len);
 		stats->tx_errors++;
+		printk(KERN_WARNING
+		       "klips_error:ipsec_tunnel_start_xmit: "
+		       "tried to __skb_pull nh-data=%d, %d available.  This should never happen, please report.\n",
+		       skb->nh.raw - skb->data, skb->len);
 		goto cleanup;
 	}
 	__skb_pull(skb, skb->nh.raw - skb->data);
@@ -1736,8 +1894,10 @@
 #endif /* SKB_RESET_NFCT */
 	KLIPS_PRINT(debug_tunnel & DB_TN_XMIT,
 		    "klips_debug:ipsec_tunnel_start_xmit: "
-		    "...done, calling ip_send()\n");
-#ifdef NETDEV_23
+		    "...done, calling ip_send() on device:%s\n",
+		    skb->dev ? skb->dev->name : "NULL");
+	KLIPS_IP_PRINT(debug_tunnel & DB_TN_XMIT, skb->nh.iph);
+#ifdef NETDEV_23	/* 2.4 kernels */
 	{
 		int err;
 
@@ -1746,7 +1906,8 @@
 		if(err != NET_XMIT_SUCCESS && err != NET_XMIT_CN) {
 			if(net_ratelimit())
 				printk(KERN_ERR
-				       "ipsec_tunnel_start_xmit: ip_send() failed, err=%d\n", 
+				       "klips_error:ipsec_tunnel_start_xmit: "
+				       "ip_send() failed, err=%d\n", 
 				       -err);
 			stats->tx_errors++;
 			stats->tx_aborted_errors++;
@@ -1754,10 +1915,10 @@
 			goto cleanup;
 		}
 	}
-#else
+#else /* NETDEV_23 */	/* 2.2 kernels */
 	ip_send(skb);
-#endif
-#else /* NET_21 */
+#endif /* NETDEV_23 */
+#else /* NET_21 */	/* 2.0 kernels */
 	skb->arp = 1;
 	/* ISDN/ASYNC PPP from Matjaz Godec. */
 	/*	skb->protocol = htons(ETH_P_IP); */
@@ -1772,16 +1933,18 @@
  cleanup:
 #if defined(HAS_NETIF_QUEUE) || defined (HAVE_NETIF_QUEUE)
 	netif_wake_queue(dev);
-#else
+#else /* defined(HAS_NETIF_QUEUE) || defined (HAVE_NETIF_QUEUE) */
 	dev->tbusy = 0;
-#endif
-	if(saved_header)
+#endif /* defined(HAS_NETIF_QUEUE) || defined (HAVE_NETIF_QUEUE) */
+	if(saved_header) {
 		kfree(saved_header);
+	}
 	if(skb) {
 		dev_kfree_skb(skb, FREE_WRITE);
 	}
-	if(oskb)
+	if(oskb) {
 		dev_kfree_skb(oskb, FREE_WRITE);
+	}
 	return 0;
 }
 
@@ -1803,6 +1966,46 @@
 	struct ipsecpriv *prv = dev->priv;
 	struct device *tmp;
 	int ret;
+	struct net_device_stats *stats;	/* This device's statistics */
+	
+	if(skb == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+			    "klips_debug:ipsec_tunnel_hard_header: "
+			    "no skb...");
+		return -ENODATA;
+	}
+
+	if(dev == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+			    "klips_debug:ipsec_tunnel_hard_header: "
+			    "no device...");
+		return -ENODEV;
+	}
+
+	KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+		    "klips_debug:ipsec_tunnel_hard_header: "
+		    "skb->dev=%s dev=%s.",
+		    skb->dev ? skb->dev->name : "NULL",
+		    dev->name);
+	
+	if(prv == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+			    "klips_debug:ipsec_tunnel_hard_header: "
+			    "no private space associated with dev=%s",
+			    dev->name ? dev->name : "NULL");
+		return -ENODEV;
+	}
+
+	stats = (struct net_device_stats *) &(prv->mystats);
+
+	if(prv->dev == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+			    "klips_debug:ipsec_tunnel_hard_header: "
+			    "no physical device associated with dev=%s",
+			    dev->name ? dev->name : "NULL");
+		stats->tx_dropped++;
+		return -ENODEV;
+	}
 
 	/* check if we have to send a IPv6 packet. It might be a Router
 	   Solicitation, where the building of the packet happens in
@@ -1820,9 +2023,12 @@
 		if(!prv->hard_header) {
 			KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
 				    "klips_debug:ipsec_tunnel_hard_header: "
-				    "physical device has been detached, packet dropped "
-				    "0x%p->0x%p len=%d type=%d dev=%s->NULL ",
-				    saddr, daddr, len, type, dev->name);
+				    "physical device has been detached, packet dropped 0x%p->0x%p len=%d type=%d dev=%s->NULL ",
+				    saddr,
+				    daddr,
+				    len,
+				    type,
+				    dev->name);
 #ifdef NET_21
 			KLIPS_PRINTMORE(debug_tunnel & DB_TN_REVEC,
 					"ip=%08x->%08x\n",
@@ -1834,15 +2040,20 @@
 					(__u32)ntohl(skb->ip_hdr->saddr),
 					(__u32)ntohl(skb->ip_hdr->daddr) );
 #endif /* NET_21 */
+			stats->tx_dropped++;
 			return -ENODEV;
 		}
 		
 #define da ((struct device *)(prv->dev))->dev_addr
 		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
 			    "klips_debug:ipsec_tunnel_hard_header: "
-			    "Revectored 0x%p->0x%p len=%d type=%d dev=%s->%s "
-			    "dev_addr=%02x:%02x:%02x:%02x:%02x:%02x ",
-			    saddr, daddr, len, type, dev->name, prv->dev->name,
+			    "Revectored 0x%p->0x%p len=%d type=%d dev=%s->%s dev_addr=%02x:%02x:%02x:%02x:%02x:%02x ",
+			    saddr,
+			    daddr,
+			    len,
+			    type,
+			    dev->name,
+			    prv->dev->name,
 			    da[0], da[1], da[2], da[3], da[4], da[5]);
 #ifdef NET_21
 		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
@@ -1878,12 +2089,38 @@
 	struct ipsecpriv *prv = skb->dev->priv;
 	struct device *tmp;
 	int ret;
+	struct net_device_stats *stats;	/* This device's statistics */
+	
+	if(skb->dev == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+			    "klips_debug:ipsec_tunnel_rebuild_header: "
+			    "no device...");
+		return -ENODEV;
+	}
+
+	if(prv == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+			    "klips_debug:ipsec_tunnel_rebuild_header: "
+			    "no private space associated with dev=%s",
+			    skb->dev->name ? skb->dev->name : "NULL");
+		return -ENODEV;
+	}
+
+	stats = (struct net_device_stats *) &(prv->mystats);
+
+	if(prv->dev == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+			    "klips_debug:ipsec_tunnel_rebuild_header: "
+			    "no physical device associated with dev=%s",
+			    skb->dev->name ? skb->dev->name : "NULL");
+		stats->tx_dropped++;
+		return -ENODEV;
+	}
 	
 	if(!prv->rebuild_header) {
 		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
 			    "klips_debug:ipsec_tunnel_rebuild_header: "
-			    "physical device has been detached, packet dropped "
-			    "skb->dev=%s->NULL ",
+			    "physical device has been detached, packet dropped skb->dev=%s->NULL ",
 			    skb->dev->name);
 #ifdef NET_21
 		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
@@ -1896,6 +2133,7 @@
 			    (__u32)ntohl(skb->ip_hdr->saddr),
 			    (__u32)ntohl(skb->ip_hdr->daddr) );
 #endif /* NET_21 */
+		stats->tx_dropped++;
 		return -ENODEV;
 	}
 
@@ -1931,11 +2169,38 @@
 {
 	struct ipsecpriv *prv = dev->priv;
 	
+	struct net_device_stats *stats;	/* This device's statistics */
+	
+	if(dev == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+			    "klips_debug:ipsec_tunnel_set_mac_address: "
+			    "no device...");
+		return -ENODEV;
+	}
+
+	if(prv == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+			    "klips_debug:ipsec_tunnel_set_mac_address: "
+			    "no private space associated with dev=%s",
+			    dev->name ? dev->name : "NULL");
+		return -ENODEV;
+	}
+
+	stats = (struct net_device_stats *) &(prv->mystats);
+
+	if(prv->dev == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+			    "klips_debug:ipsec_tunnel_set_mac_address: "
+			    "no physical device associated with dev=%s",
+			    dev->name ? dev->name : "NULL");
+		stats->tx_dropped++;
+		return -ENODEV;
+	}
+
 	if(!prv->set_mac_address) {
 		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
 			    "klips_debug:ipsec_tunnel_set_mac_address: "
-			    "physical device has been detached, cannot set - "
-			    "skb->dev=%s->NULL\n",
+			    "physical device has been detached, cannot set - skb->dev=%s->NULL\n",
 			    dev->name);
 		return -ENODEV;
 	}
@@ -1955,12 +2220,40 @@
 {
 	struct ipsecpriv *prv = dev->priv;
 	
+	struct net_device_stats *stats;	/* This device's statistics */
+	
+	if(dev == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+			    "klips_debug:ipsec_tunnel_cache_bind: "
+			    "no device...");
+		return;
+	}
+
+	if(prv == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+			    "klips_debug:ipsec_tunnel_cache_bind: "
+			    "no private space associated with dev=%s",
+			    dev->name ? dev->name : "NULL");
+		return;
+	}
+
+	stats = (struct net_device_stats *) &(prv->mystats);
+
+	if(prv->dev == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+			    "klips_debug:ipsec_tunnel_cache_bind: "
+			    "no physical device associated with dev=%s",
+			    dev->name ? dev->name : "NULL");
+		stats->tx_dropped++;
+		return;
+	}
+
 	if(!prv->header_cache_bind) {
 		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
 			    "klips_debug:ipsec_tunnel_cache_bind: "
-			    "physical device has been detached, cannot set - "
-			    "skb->dev=%s->NULL\n",
+			    "physical device has been detached, cannot set - skb->dev=%s->NULL\n",
 			    dev->name);
+		stats->tx_dropped++;
 		return;
 	}
 
@@ -1978,11 +2271,38 @@
 {
 	struct ipsecpriv *prv = dev->priv;
 	
+	struct net_device_stats *stats;	/* This device's statistics */
+	
+	if(dev == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+			    "klips_debug:ipsec_tunnel_cache_update: "
+			    "no device...");
+		return;
+	}
+
+	if(prv == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+			    "klips_debug:ipsec_tunnel_cache_update: "
+			    "no private space associated with dev=%s",
+			    dev->name ? dev->name : "NULL");
+		return;
+	}
+
+	stats = (struct net_device_stats *) &(prv->mystats);
+
+	if(prv->dev == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+			    "klips_debug:ipsec_tunnel_cache_update: "
+			    "no physical device associated with dev=%s",
+			    dev->name ? dev->name : "NULL");
+		stats->tx_dropped++;
+		return;
+	}
+
 	if(!prv->header_cache_update) {
 		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
 			    "klips_debug:ipsec_tunnel_cache_update: "
-			    "physical device has been detached, cannot set - "
-			    "skb->dev=%s->NULL\n",
+			    "physical device has been detached, cannot set - skb->dev=%s->NULL\n",
 			    dev->name);
 		return;
 	}
@@ -1999,8 +2319,7 @@
 ipsec_tunnel_neigh_setup(struct neighbour *n)
 {
 	KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
-		    "klips_debug:ipsec_tunnel: "
-		    "ipsec_tunnel_neigh_setup\n");
+		    "klips_debug:ipsec_tunnel_neigh_setup:\n");
 
         if (n->nud_state == NUD_NONE) {
                 n->ops = &arp_broken_ops;
@@ -2013,8 +2332,9 @@
 ipsec_tunnel_neigh_setup_dev(struct device *dev, struct neigh_parms *p)
 {
 	KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
-		    "klips_debug:ipsec_tunnel: "
-		    "ipsec_tunnel_neigh_setup_dev\n");
+		    "klips_debug:ipsec_tunnel_neigh_setup_dev: "
+		    "setting up %s\n",
+		    dev ? dev->name : "NULL");
 
         if (p->tbl->family == AF_INET) {
                 p->neigh_setup = ipsec_tunnel_neigh_setup;
@@ -2030,70 +2350,86 @@
  */
 
 DEBUG_NO_STATIC int
-ipsec_tunnel_attach(struct device *tndev, struct ipsecpriv *prv, struct device *dev)
+ipsec_tunnel_attach(struct device *dev, struct device *physdev)
 {
         int i;
+	struct ipsecpriv *prv = dev->priv;
+
+	if(dev == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+			    "klips_debug:ipsec_tunnel_attach: "
+			    "no device...");
+		return -ENODEV;
+	}
 
-	prv->dev = dev;
-	prv->hard_start_xmit = dev->hard_start_xmit;
-	prv->get_stats = dev->get_stats;
-
-	if (dev->hard_header) {
-		prv->hard_header = dev->hard_header;
-		tndev->hard_header = ipsec_tunnel_hard_header;
+	if(prv == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+			    "klips_debug:ipsec_tunnel_attach: "
+			    "no private space associated with dev=%s",
+			    dev->name ? dev->name : "NULL");
+		return -ENODATA;
+	}
+
+	prv->dev = physdev;
+	prv->hard_start_xmit = physdev->hard_start_xmit;
+	prv->get_stats = physdev->get_stats;
+
+	if (physdev->hard_header) {
+		prv->hard_header = physdev->hard_header;
+		dev->hard_header = ipsec_tunnel_hard_header;
 	} else
-		tndev->hard_header = NULL;
+		dev->hard_header = NULL;
 	
-	if (dev->rebuild_header) {
-		prv->rebuild_header = dev->rebuild_header;
-		tndev->rebuild_header = ipsec_tunnel_rebuild_header;
+	if (physdev->rebuild_header) {
+		prv->rebuild_header = physdev->rebuild_header;
+		dev->rebuild_header = ipsec_tunnel_rebuild_header;
 	} else
-		tndev->rebuild_header = NULL;
+		dev->rebuild_header = NULL;
 	
-	if (dev->set_mac_address) {
-		prv->set_mac_address = dev->set_mac_address;
-		tndev->set_mac_address = ipsec_tunnel_set_mac_address;
+	if (physdev->set_mac_address) {
+		prv->set_mac_address = physdev->set_mac_address;
+		dev->set_mac_address = ipsec_tunnel_set_mac_address;
 	} else
-		tndev->set_mac_address = NULL;
+		dev->set_mac_address = NULL;
 	
 #ifndef NET_21
-	if (dev->header_cache_bind) {
-		prv->header_cache_bind = dev->header_cache_bind;
-		tndev->header_cache_bind = ipsec_tunnel_cache_bind;
+	if (physdev->header_cache_bind) {
+		prv->header_cache_bind = physdev->header_cache_bind;
+		dev->header_cache_bind = ipsec_tunnel_cache_bind;
 	} else
-		tndev->header_cache_bind = NULL;
+		dev->header_cache_bind = NULL;
 #endif /* !NET_21 */
 
-	if (dev->header_cache_update) {
-		prv->header_cache_update = dev->header_cache_update;
-		tndev->header_cache_update = ipsec_tunnel_cache_update;
+	if (physdev->header_cache_update) {
+		prv->header_cache_update = physdev->header_cache_update;
+		dev->header_cache_update = ipsec_tunnel_cache_update;
 	} else
-		tndev->header_cache_update = NULL;
+		dev->header_cache_update = NULL;
 
-	tndev->hard_header_len = dev->hard_header_len;
+	dev->hard_header_len = physdev->hard_header_len;
 
 #ifdef NET_21
-/*	prv->neigh_setup        = dev->neigh_setup; */
+/*	prv->neigh_setup        = physdev->neigh_setup; */
 	dev->neigh_setup        = ipsec_tunnel_neigh_setup_dev;
 #endif /* NET_21 */
-	tndev->mtu = 16260; /* 0xfff0; */ /* dev->mtu; */
-	prv->mtu = dev->mtu;
+	dev->mtu = 16260; /* 0xfff0; */ /* dev->mtu; */
+	prv->mtu = physdev->mtu;
 
 #ifdef PHYSDEV_TYPE
-	tndev->type = dev->type /* ARPHRD_TUNNEL */;	/* initially */
+	dev->type = physdev->type /* ARPHRD_TUNNEL */;	/* initially */
 #endif /*  PHYSDEV_TYPE */
 
-	tndev->addr_len = dev->addr_len;
-	for (i=0; i<tndev->addr_len; i++) {
-		tndev->dev_addr[i] = dev->dev_addr[i];
+	dev->addr_len = physdev->addr_len;
+	for (i=0; i<dev->addr_len; i++) {
+		dev->dev_addr[i] = physdev->dev_addr[i];
 	}
 #ifdef CONFIG_IPSEC_DEBUG
 	if(debug_tunnel & DB_TN_INIT) {
 		printk(KERN_INFO "klips_debug:ipsec_tunnel_attach: "
 		       "physical device %s being attached has HW address: %2x",
-		       dev->name, dev->dev_addr[0]);
-		for (i=1; i < dev->addr_len; i++) {
-			printk(":%02x", dev->dev_addr[i]);
+		       physdev->name, physdev->dev_addr[0]);
+		for (i=1; i < physdev->addr_len; i++) {
+			printk(":%02x", physdev->dev_addr[i]);
 		}
 		printk("\n");
 	}
@@ -2107,49 +2443,80 @@
  */
 
 DEBUG_NO_STATIC int
-ipsec_tunnel_detach(struct device *dev, struct ipsecpriv *prv)
+ipsec_tunnel_detach(struct device *dev)
 {
         int i;
+	struct ipsecpriv *prv = dev->priv;
+
+	if(dev == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+			    "klips_debug:ipsec_tunnel_detach: "
+			    "no device...");
+		return -ENODEV;
+	}
+
+	if(prv == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_REVEC,
+			    "klips_debug:ipsec_tunnel_detach: "
+			    "no private space associated with dev=%s",
+			    dev->name ? dev->name : "NULL");
+		return -ENODATA;
+	}
 
 	KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
 		    "klips_debug:ipsec_tunnel_detach: "
 		       "physical device %s being detached from virtual device %s\n",
-		       prv->dev->name, dev->name);
+		    prv->dev ? prv->dev->name : "NULL",
+		    dev->name);
 
 	prv->dev = NULL;
 	prv->hard_start_xmit = NULL;
 	prv->get_stats = NULL;
 
 	prv->hard_header = NULL;
+#ifdef DETACH_AND_DOWN
 	dev->hard_header = NULL;
+#endif /* DETACH_AND_DOWN */
 	
 	prv->rebuild_header = NULL;
+#ifdef DETACH_AND_DOWN
 	dev->rebuild_header = NULL;
+#endif /* DETACH_AND_DOWN */
 	
 	prv->set_mac_address = NULL;
+#ifdef DETACH_AND_DOWN
 	dev->set_mac_address = NULL;
+#endif /* DETACH_AND_DOWN */
 	
 #ifndef NET_21
 	prv->header_cache_bind = NULL;
+#ifdef DETACH_AND_DOWN
 	dev->header_cache_bind = NULL;
+#endif /* DETACH_AND_DOWN */
 #endif /* !NET_21 */
 
 	prv->header_cache_update = NULL;
+#ifdef DETACH_AND_DOWN
 	dev->header_cache_update = NULL;
+#endif /* DETACH_AND_DOWN */
 
 #ifdef NET_21
 /*	prv->neigh_setup        = NULL; */
+#ifdef DETACH_AND_DOWN
 	dev->neigh_setup        = NULL;
+#endif /* DETACH_AND_DOWN */
 #endif /* NET_21 */
 	dev->hard_header_len = 0;
+#ifdef DETACH_AND_DOWN
 	dev->mtu = 0;
+#endif /* DETACH_AND_DOWN */
 	prv->mtu = 0;
 	for (i=0; i<MAX_ADDR_LEN; i++) {
 		dev->dev_addr[i] = 0;
 	}
 	dev->addr_len = 0;
 #ifdef PHYSDEV_TYPE
-	dev->type = 0;
+	dev->type = ARPHRD_TUNNEL;
 #endif /*  PHYSDEV_TYPE */
 	
 	return 0;
@@ -2168,7 +2535,7 @@
 	int ret;
 
 	KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
-		    "klips_debug:ipsec_tunnel_clear: called.\n");
+		    "klips_debug:ipsec_tunnel_clear: .\n");
 
 	for(i = 0; i < IPSEC_NUM_IF; i++) {
 		sprintf(name, "ipsec%d", i);
@@ -2180,7 +2547,7 @@
 						    "klips_debug:ipsec_tunnel_clear: "
 						    "physical device for device %s is %s\n",
 						    name, prvdev->name);
-					if((ret = ipsec_tunnel_detach(ipsecdev, prv))) {
+					if((ret = ipsec_tunnel_detach(ipsecdev))) {
 						KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
 							    "klips_debug:ipsec_tunnel_clear: "
 							    "error %d detatching device %s from device %s.\n",
@@ -2205,12 +2572,24 @@
 	char realphysname[IFNAMSIZ];
 #endif /* CONFIG_IP_ALIAS */
 	
+	if(dev == NULL) {
 	KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
 		    "klips_debug:ipsec_tunnel_ioctl: "
-		    "tncfg service call #%d\n", cmd);
+			    "device not supplied.\n");
+		return -ENODEV;
+	}
+
+	KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
+		    "klips_debug:ipsec_tunnel_ioctl: "
+		    "tncfg service call #%d for dev=%s\n",
+		    cmd,
+		    dev->name ? dev->name : "NULL");
 	switch (cmd) {
 	/* attach a virtual ipsec? device to a physical device */
 	case IPSEC_SET_DEV:
+		KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
+			    "klips_debug:ipsec_tunnel_ioctl: "
+			    "calling ipsec_tunnel_attatch...\n");
 #ifdef CONFIG_IP_ALIAS
 		/* If this is an IP alias interface, get its real physical name */
 		strncpy(realphysname, cf->cf_name, IFNAMSIZ);
@@ -2225,19 +2604,41 @@
 		if (them == NULL) {
 			KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
 				    "klips_debug:ipsec_tunnel_ioctl: "
-				    "physical device requested is null\n");
+				    "physical device %s requested is null\n",
+				    cf->cf_name);
+			return -ENXIO;
+		}
 
+#if 0
+		if (them->flags & IFF_UP) {
+			KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
+				    "klips_debug:ipsec_tunnel_ioctl: "
+				    "physical device %s requested is not up.\n",
+				    cf->cf_name);
 			return -ENXIO;
 		}
+#endif
 		
-		if (prv->dev)
+		if (prv && prv->dev) {
+			KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
+				    "klips_debug:ipsec_tunnel_ioctl: "
+				    "virtual device is already connected to %s.\n",
+				    prv->dev->name ? prv->dev->name : "NULL");
 			return -EBUSY;
-		return ipsec_tunnel_attach(dev, dev->priv, them);
+		}
+		return ipsec_tunnel_attach(dev, them);
 
 	case IPSEC_DEL_DEV:
-		if (! prv->dev)
+		KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
+			    "klips_debug:ipsec_tunnel_ioctl: "
+			    "calling ipsec_tunnel_detatch.\n");
+		if (! prv->dev) {
+			KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
+				    "klips_debug:ipsec_tunnel_ioctl: "
+				    "physical device not connected.\n");
 			return -ENODEV;
-		return ipsec_tunnel_detach(dev, dev->priv);
+		}
+		return ipsec_tunnel_detach(dev);
 	       
 	case IPSEC_CLR_DEV:
 		KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
@@ -2246,6 +2647,10 @@
 		return ipsec_tunnel_clear();
 
 	default:
+		KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
+			    "klips_debug:ipsec_tunnel_ioctl: "
+			    "unknown command %d.\n",
+			    cmd);
 		return -EOPNOTSUPP;
 	}
 }
@@ -2259,15 +2664,45 @@
 	char name[9];
 	int i;
 
+	if (dev == NULL) {
+		KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
+			    "klips_debug:ipsec_device_event: "
+			    "dev=NULL for event type %ld.\n",
+			    event);
+		return(NOTIFY_DONE);
+	}
+
 	/* check for loopback devices */
-	if (dev->flags & IFF_LOOPBACK)
+	if (dev && (dev->flags & IFF_LOOPBACK)) {
 		return(NOTIFY_DONE);
+	}
 
-	switch (event) 
-	{
+	switch (event) {
+	case NETDEV_DOWN:
+		/* look carefully at the scope of these compiler
+		   #defines before changing anything... */
+#ifdef NET_21
+	case NETDEV_UNREGISTER:
+		switch (event) {
 		case NETDEV_DOWN:
+#endif /* NET_21 */
 			KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
-				    "ipsec_device_event: NETDEV_DOWN...\n");
+				    "klips_debug:ipsec_device_event: "
+				    "NETDEV_DOWN dev=%s flags=%x\n",
+				    dev->name,
+				    dev->flags);
+#ifdef NET_21
+			break;
+		case NETDEV_UNREGISTER:
+			KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
+				    "klips_debug:ipsec_device_event: "
+				    "NETDEV_UNREGISTER dev=%s flags=%x\n",
+				    dev->name,
+				    dev->flags);
+			break;
+		}
+#endif /* NET_21 */
+		
 			/* find the attached physical device and detach it. */
 			for(i = 0; i < IPSEC_NUM_IF; i++) {
 				sprintf(name, "ipsec%d", i);
@@ -2277,35 +2712,82 @@
 					if(priv) {
 						;
 						if(((struct device *)(priv->dev)) == dev) {
-							dev_close(ipsec_dev);
-							/* return */ ipsec_tunnel_detach(ipsec_dev, priv);
-							return NOTIFY_DONE;
+						/* dev_close(ipsec_dev); */
+						/* return */ ipsec_tunnel_detach(ipsec_dev);
+						KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
+							    "klips_debug:ipsec_device_event: "
+							    "device '%s' has been detached.\n",
+							    ipsec_dev->name);
 							break;
 						}
 					} else {
 						KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
-							    "klips_debug:ipsec_device_event: device '%s' has no private data space!\n",
+						    "klips_debug:ipsec_device_event: "
+						    "device '%s' has no private data space!\n",
 							    ipsec_dev->name);
 					}
 				}
 			}
-
 			break;
 		case NETDEV_UP:
 			KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
-				    "ipsec_device_event: NETDEV_UP...\n");
-			/* Only handle ethernet ports */
-			if(dev->type!=ARPHRD_ETHER && dev->type!=ARPHRD_LOOPBACK)
-				return NOTIFY_DONE;
-
+			    "klips_debug:ipsec_device_event: "
+			    "NETDEV_UP dev=%s\n",
+			    dev->name);
 			break;
 #ifdef NET_21
-		case NETDEV_UNREGISTER:
+	case NETDEV_REBOOT:
 			KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
-				    "ipsec_device_event: NETDEV_UNREGISTER...\n");
-
+			    "klips_debug:ipsec_device_event: "
+			    "NETDEV_REBOOT dev=%s\n",
+			    dev->name);
+		break;
+	case NETDEV_CHANGE:
+		KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
+			    "klips_debug:ipsec_device_event: "
+			    "NETDEV_CHANGE dev=%s flags=%x\n",
+			    dev->name,
+			    dev->flags);
+		break;
+	case NETDEV_REGISTER:
+		KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
+			    "klips_debug:ipsec_device_event: "
+			    "NETDEV_REGISTER dev=%s\n",
+			    dev->name);
+		break;
+	case NETDEV_CHANGEMTU:
+		KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
+			    "klips_debug:ipsec_device_event: "
+			    "NETDEV_CHANGEMTU dev=%s to mtu=%d\n",
+			    dev->name,
+			    dev->mtu);
+		break;
+	case NETDEV_CHANGEADDR:
+		KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
+			    "klips_debug:ipsec_device_event: "
+			    "NETDEV_CHANGEADDR dev=%s\n",
+			    dev->name);
+		break;
+	case NETDEV_GOING_DOWN:
+		KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
+			    "klips_debug:ipsec_device_event: "
+			    "NETDEV_GOING_DOWN dev=%s\n",
+			    dev->name);
+		break;
+	case NETDEV_CHANGENAME:
+		KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
+			    "klips_debug:ipsec_device_event: "
+			    "NETDEV_CHANGENAME dev=%s\n",
+			    dev->name);
 			break;
 #endif /* NET_21 */
+	default:
+		KLIPS_PRINT(debug_tunnel & DB_TN_INIT,
+			    "klips_debug:ipsec_device_event: "
+			    "event type %ld unrecognised for dev=%s\n",
+			    event,
+			    dev->name);
+		break;
 	}
 	return NOTIFY_DONE;
 }
@@ -2320,8 +2802,12 @@
 {
 	int i;
 
-	printk(KERN_INFO "IPsec: initialisation of device: %s\n",
+#if 0
+	printk(KERN_INFO
+	       "klips_debug:ipsec_tunnel_init: "
+	       "initialisation of device: %s\n",
 	       dev->name ? dev->name : "NULL");
+#endif
 
 	/* Add our tunnel functions to the device */
 	dev->open		= ipsec_tunnel_open;
